This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 530517 - Machine can't boot because nfs hangs on startup
Machine can't boot because nfs hangs on startup
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: nfs-utils (Show other bugs)
11
All Linux
low Severity medium
: ---
: ---
Assigned To: Steve Dickson
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-10-23 05:25 EDT by Mads Kiilerich
Modified: 2010-06-28 11:06 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-06-28 11:06:49 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Mads Kiilerich 2009-10-23 05:25:39 EDT
Description of problem:

I just noticed that if rpcbind isn't started properly on boot then the machine will hang trying to start the nfs service. 

It might be an administrator error and a quite fatal one, but it shouldn't cause the machine to hang during boot; that makes it very hard to resolve the problem, especially if it is a remote machine.

(Trying to reproduce it it seems like it might time out after something like 5 minutes. But that is too long, IMHO, especially when no critical nfs mounts has been defined.)

In worst case I would expect it to fail with an error after at most 30 seconds.


[root@localhost ~]# service rpcbind status
rpcbind is stopped
[root@localhost ~]# service nfs start
Starting NFS services:                                     [  OK  ]
Starting NFS quotas: Cannot register service: RPC: Unable to receive; errno = Connection refused
rpc.rquotad: unable to register (RQUOTAPROG, RQUOTAVERS, udp).
                                                           [FAILED]
Starting NFS daemon: 
[hanging]


Version-Release number of selected component (if applicable):

nfs-utils-1.2.0-6.fc11.i586
Comment 1 Steve Dickson 2009-10-23 09:08:59 EDT
The problem is during this hang, the daemon is trying to connect
to rpcbind making the assumption rpcbind is on its way back. 
This is by design and a design that common through out all
of the NFS/RPC code.

Plus timeouts are funny things... at one place they are too long
and others they are not long enough... So it not clear what can 
be done to satisfy both camps...
Comment 2 Mads Kiilerich 2009-10-23 09:22:22 EDT
For me with my luser-on-a-workstation-and-occasional-nfs-user-hat on I think it would be fine if /etc/rc.d/init.d/nfs acknowledged its dependency on rpcbind and bailed out early if rpcbind hadn't been started - for example by checking /var/run/rpcbind* or /var/lock/subsys/rpcbind.

I assume that those who would like to wait for rpcbind also knows how to start it, and that if they fail to start it then they can't expect anything.
Comment 3 Steve Dickson 2009-10-23 09:47:23 EDT
hmm... I agree that is a good way to test for rpcbind's existence...
but I'm just sure about bailing out because NFS v4 servers don't need
rpcbind to exist and there is not a "only-support-v4' mode in the 
init script... although that might be in the feature...
Comment 4 Mads Kiilerich 2009-10-23 10:11:38 EDT
Hmm. I didn't know that NFS v4 was special in that way.


But to summarize my experience/opinion:

Just enabling the nfs service without enabling the rpcbind service shouldn't make the machine lock up.

Waiting for a long time or forever for rpcbind to show up are valid usecases, but not common ones. Such setups will require special setup anyway, and the administrator will have to specify if it should wait for 5 minutes or forever anyway.


How about making the timeout configurable in /etc/sysconfig/nfs and defaulting to 5 seconds?
Comment 5 Bug Zapper 2010-04-28 06:56:15 EDT
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 6 Bug Zapper 2010-06-28 11:06:49 EDT
Fedora 11 changed to end-of-life (EOL) status on 2010-06-25. Fedora 11 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.